require 'aws-sdk'
require 'renderCFN/stack'

module RenderCFN
  class NestedStack < Stack
    def initialize( arguments)
  
      @serviceTitle = arguments[:serviceTitle] or nil
      @serviceName = arguments[:serviceName] or nil
      @nestedStackName = "#{@serviceName}NestedStack"
  
      unless @serviceTitle and @serviceName then
        print "Please set serviceTitle and serviceName\n"
      end
  
      @stackID = String.new()
      @templateName = "#{@serviceName}.yml"
      @templateURL = "https://s3.amazonaws.com/#{@@bucket}/stacks/#{@@stackName}/#{@templateName}"
  
      @awsObject = { 
        'AWSTemplateFormatVersion' => '2010-09-09',
        'Description' => arguments[:description] ? "#{arguments[:description]} [renderCFN]" : 'Made with renderCFN',
        'Resources' => {} ,
        'Parameters' => {}
      }
  
      @nestedStackObject = {
        @nestedStackName => {
          'Type' => 'AWS::CloudFormation::Stack',
          'Properties' => {
            'TemplateURL' => @templateURL,
            'Parameters' => {}
          }
        }
      }
  
    end
  
    def addParameter( dependentObject, type)
      @awsObject['Parameters'].merge!( dependentObject => { 'Type' => type }  )
      @nestedStackObject[@nestedStackName]['Properties']['Parameters'].merge!( dependentObject => { 'Ref' => dependentObject } )
    end
  
    def getNestedStack()
      uploadTemplate()
      @nestedStackObject
    end
  
  end

end
