require 'renderCFN/awsObject'

module RenderCFN
  class Role < AwsObject
      def initialize( name)
        @name = "#{name}Role"
        @awsObject = { 
          @name => {
            'Type' => 'AWS::IAM::Role',
            'Properties' => {
              'AssumeRolePolicyDocument' => {
                'Statement' => [
                  'Effect' => 'Allow',
                  'Principal' => {
                    'Service' => [
                      'ec2.amazonaws.com'
                    ]
                  },
                  'Action' => [
                    'sts:AssumeRole'
                  ]
                ]
              },
              'Path' => '/',
              'Policies' => []
            }
          }
        }
      end

      def addPolicy( name, action = Array.new, resource = Array.new)
        @awsObject[@name]['Properties']['Policies'].push( 
          'PolicyName' => name,
          'PolicyDocument' => {
            'Statement' => [
              'Effect' => 'Allow',
              'Action' => action,
              'Resource' => resource
            ]
          }
        )
      end

  end
end
