require 'renderCFN/awsObject'

module RenderCFN
  class SQS < AwsObject
      def initialize( arguments)
        @name = "#{arguments[:name]}"
        @title = "#{arguments[:title]}"
        @awsObject = { 
          @title => {
            'Type' => 'AWS::SQS::Queue',
            'Properties' => {
              'QueueName' => arguments[:name],
              'DelaySeconds' => arguments[:delaySeconds],
              'MaximumMessageSize' => arguments[:maximumMessageSize],
              'MessageRetentionPeriod' => arguments[:messageRetentionPeriod],
              'ReceiveMessageWaitTimeSeconds' => arguments[:receiveMessageWaitTimeSeconds],
              'VisibilityTimeout' => arguments[:visibilityTimeout]
            },
            'DependsOn' => []
          }
        }
      end

      def redrivePolicy( queueTarget, maxRecvCount)
        @awsObject[@title]['Properties']['RedrivePolicy'] = {
          'deadLetterTargetArn' => queueTarget,
          'maxReceiveCount' => maxRecvCount
        }
      end

      def dependsOn(name)
        @awsObject[@title]['DependsOn'].push(name)
      end
  
  end

end
