#!/usr/bin/env ruby

require 'yaml'
require 'aws-sdk'
require 'renderCFN/awsObject'

module RenderCFN
  class Stack < AwsObject
  
    def initialize( arguments)
  
      super( arguments)
      @stackID = String.new()
      @templateName = 'main.yml'
      @templateURL = "https://s3.amazonaws.com/#{@@bucket}/stacks/#{@@stackName}/#{@templateName}"
  
      unless @@action then
        print "Must set action.\n"
      end
  
      unless @@stackType and @@environmentType and @@environmentName then 
        print "Must set arguments for to stack name.\n"
        exit 1
      end
  
      unless @@action == 'create' or @@action == 'print' then
        @@stackID = getAWSStackID()
      end
  
      @awsObject = Hash.new
  
    end
  
    def render 
      YAML.dump(self.get)
    end
  
    def add( thing)
      @awsObject['Resources'].merge!(thing)
    end
  
    def uploadTemplate( )
      s3 = Aws::S3::Resource.new(region:'us-east-1')
      obj = s3.bucket(@@bucket).object("stacks/#{@@stackName}/#{@templateName}")
      obj.put(body: render)
    end
  
  end

end
